@{import os}
@{extension =  os.path.splitext(src)[1]}

@{
import shelve
import requests

def convert(image_file):
    import base64
    content_base64 = base64.b64encode(image_file)
    return 'data:image/png;base64,' + content_base64.decode('utf-8')

file_path = src
with shelve.open('.kooki_images') as image_db:
    file_result = ''
    try:
        file_result = image_db[str(file_path)]
    except KeyError:
        try:
            response = requests.get(file_path)
            image_file = response.content
            file_result = convert(image_file)
            image_db[str(file_path)] = file_result
        except requests.exceptions.MissingSchema:
            with open(find(file_path), 'rb') as image_file:
                file_result = convert(image_file.read())

}

@[if extension in ['.webm', '.ogg', '.mp4']]
<video height="600" controls muted alt="@alt_text">
  <source src="@file_result" type="video/webm">
  Your browser does not support the video tag.
</video>
@[elif extension in '.svg']
<div class="@alt_text">
  @src @extension
</div>
@[else]
<img src="@file_result" title="@title" alt="@alt_text"/>
@[end if]